Require Import Peano_dec.
Require Import Compare_dec.
Require Import Lt.
Require Import Omega.

Require Import base.
Require Import ut_term.
Require Import ut_red.
Require Import ut_env.
Require Import ut_typ.
Require Import ut_sr.
Require Import term.
Require Import env.
Require Import typ_annot.
Require Import glue.
Require Import List.
Require Import strip.

Open Scope Typ_scope.

Lemma strip_var_ : forall Γ x A, A↓ x ∈ Γ -> ((strip A)↓ x ∈ (strip_env Γ))%UT.
induction Γ; intros.
inversion H.
inversion H; intros; subst.
simpl; constructor.
simpl. intuition.
Qed.

Lemma strip_var : forall Γ x A, A ↓ x ⊂ Γ -> ((strip A) ↓ x ⊂ (strip_env Γ))%UT.
intros. destruct H as (a  & ? & ?).
apply strip_var_ in H0. exists (strip a); intuition.
rewrite <- strip_lift. rewrite H. trivial.
Qed.




Lemma FromTPOSR_to_PTS : (forall Γ M N T, Γ ⊢ M ▹ N : T -> (strip_env Γ) ⊢  (strip M) : (strip T) /\
   (strip_env Γ) ⊢ (strip N) : (strip T) /\ (strip M) ≡ (strip N)) /\
 (forall Γ, Γ ⊣ -> ((strip_env Γ) ⊣)%UT).
apply typ_induc; intros; simpl in *.
split. apply strip_var in i. intuition.
split. apply strip_var in i. intuition.
trivial.
(**)
intuition.
(**)
destruct H as (? & ?& ?), H0 as (? & ? & ?).
split. apply cPi with s1 s2; trivial.
split.  apply cPi with s1 s2; trivial.
apply Betac_confl in H2 as (Z & ?& ?). apply Betas_env_sound_up with (Z::(strip_env Γ)).
apply Betas_env_sound with ((strip A)::(strip_env Γ)). trivial. apply Betas_env_hd; trivial.
eauto. apply Betas_env_hd; trivial. intuition.
(**)
destruct H as (? & ?& ?), H0 as (? & ?& ?), H1 as (? & ? & ?).
split. apply cLa with s1 s2 s3; trivial. split. apply Cnv with (Π(strip A'),strip B)%UT s3.
intuition. apply cLa with s1 s2 s3; trivial. apply Betac_confl in H3 as (Z & ?& ?). apply Betas_env_sound_up with (Z::(strip_env Γ)).
apply Betas_env_sound with ((strip A)::(strip_env Γ)). trivial. apply Betas_env_hd; trivial.
eauto. apply Betas_env_hd; trivial. apply Betac_confl in H3 as (Z & ?& ?). apply Betas_env_sound_up with (Z::(strip_env Γ)).
apply Betas_env_sound with ((strip A)::(strip_env Γ)). trivial. apply Betas_env_hd; trivial.
eauto. apply Betas_env_hd; trivial. apply cPi with s1 s2; trivial. intuition.
(**)
destruct H as (? & ?& ?), H0 as (? & ?& ?), H1 as (? & ? & ?), H2 as (? & ?& ?).
split. rewrite strip_subst. apply cApp with (strip A); trivial. split. rewrite strip_subst.
apply Cnv with ((strip B)[← strip N'])%UT s2. intuition. apply cApp with (strip A); trivial.
change (!s2)%UT with (!s2[← strip N])%UT. eapply substitution. apply H0. apply H2. constructor. eauto.
intuition.
(**)
destruct H as (? & ?& ?), H0 as (? & ?& ?), H1 as (? & ? & ?), H2 as (? & ?& ?).
split. rewrite strip_subst. apply cApp with (strip A). apply cLa with s1 s2 s3; trivial. trivial.
split. rewrite 2! strip_subst. apply Cnv with ((strip B)[← strip N'])%UT s2. intuition. eapply substitution.
apply H7. apply H9. constructor. eauto. change (!s2)%UT with (!s2[← strip N])%UT. eapply substitution. apply H0. apply H2. constructor. eauto.
rewrite strip_subst. apply Betac_trans with ((strip M)[← strip N])%UT. intuition.
apply Betac_trans with ((strip M)[← strip N'])%UT. intuition. intuition.
(**)
destruct H as (? & ? & ?), H0 as (? & ?& ?).
split. apply Cnv with (strip A) s; trivial. split. apply Cnv with (strip A) s; trivial. trivial.
(**)
destruct H as (? & ? & ?), H0 as (? & ?& ?).
split. apply Cnv with (strip B) s; intuition. split. apply Cnv with (strip B) s; intuition. trivial.
(**) 
trivial.
(**)
destruct H as (? & ?& ?). eauto.
Qed.

Require Import ut_typ_eq.

Lemma FromTPOSR_to_PTSe : (forall Γ M N T, Γ ⊢ M ▹ N : T -> (strip_env Γ) ⊢e  (strip M) = (strip N)  : (strip T)) /\
 (forall Γ, (typ_annot.wf Γ) -> ((strip_env Γ) ⊣e)%UT).
apply typ_annot.typ_induc; intros; simpl in *.
(**)
apply strip_var in i. intuition.
(**)
intuition.
(**)
apply cPi_eq with s1 s2; trivial.
(**)
apply cLa_eq with s1 s2 s3; trivial. change (strip A::strip_env Γ) with( nil++strip A::strip_env Γ).
eapply conv_in_env. apply left_reflexivity in H0. apply H0. simpl; reflexivity. constructor.
apply left_reflexivity in H. apply H. apply left_reflexivity   with (strip A'); trivial.
(**)
rewrite strip_subst. apply cApp_eq with (strip A). trivial. trivial.
(**)
rewrite 2! strip_subst. apply cTrans with (strip M)[← strip N]. apply cBeta with s1 s2 s3; trivial.
apply left_reflexivity with (strip A'); trivial. apply left_reflexivity with (strip B'); trivial.
apply left_reflexivity with (strip M'); trivial. apply left_reflexivity with (strip N'); trivial.
apply cTrans with (strip M')[← strip N]. eapply substitution. apply H1. apply left_reflexivity in H2; apply H2.
constructor. eapply substitution2. apply right_reflexivity in H1; apply H1. apply H2. apply left_reflexivity with (strip N'); trivial.
constructor.
(**)
apply Cnv_eq with (strip A) s; trivial.
(**)
apply Cnv_eq with (strip B) s; intuition.
(**)
trivial.
econstructor. apply left_reflexivity in H. apply H.
Qed.

Lemma FromTPOSR_to_PTSe_trans : forall Γ M N T, Γ ⊢ M ▹▹ N : T -> (strip_env Γ) ⊢e  (strip M) = (strip N)  : (strip T).
induction 1. apply FromTPOSR_to_PTSe in H. trivial.
eauto.
Qed.


Lemma PTS_equiv_PTSe : (forall Γ M T, Γ ⊢ M : T <-> Γ ⊢e M : T) /\
  (forall Γ M N T, Γ ⊢e M = N : T <-> Γ ⊢ M : T /\ Γ ⊢ N : T /\ M ≡ N).
split. intros. split; intros.
apply FromPTS_to_TPOSR in H. destruct H as (Γ' & M' & T'& ? & ? & ? & ?).
apply FromTPOSR_to_PTSe in H2. rewrite H in H2. rewrite H0 in H2. rewrite H1 in H2. apply left_reflexivity with M; trivial.
apply FromPTSe_to_PTS in H. trivial.
(**)
intros. split; intros.
apply FromPTSe_to_PTS in H. trivial.
destruct H as ( ? & ?& ?).  apply Betac_confl in H1 as (P & ?& ?). apply cTrans with P.
apply FromPTS_to_TPOSR in H as (Γ1 & M1 & T1 & ? & ? & ?& ?).  destruct (L33' M1 P) as (P1 & ? & ?).
rewrite H3; trivial. subst. apply FromTPOSR_to_PTSe_trans. apply SR_trans' with M1; trivial.
apply cSym.
apply FromPTS_to_TPOSR in H0 as (Γ1 & N1 & T1 & ? & ? & ?& ?).  destruct (L33' N1 P) as (P1 & ? & ?).
rewrite H3; trivial. subst. apply FromTPOSR_to_PTSe_trans. apply SR_trans' with N1; trivial.
Qed.






