Require Import Peano_dec.
Require Import Compare_dec.
Require Import Lt.
Require Import Omega.

Require Import base.
Require Import ut_term.
Require Import ut_red.
Require Import ut_env.
Require Import ut_typ.
Require Import term.
Require Import env.
Require Import typ_annot.
Require Import List.
Require Import strip.

Open Scope Typ_scope.


Lemma weak_type_shape : forall Γ M N A, Γ ⊢ M ▹ N : A -> forall P B, Γ ⊢ M ▹ P : B ->
 Γ ⊢ A ≡' B \/ (exists U,exists V, Γ ⊢ M ▹ λ[U],V : A /\ Γ ⊢ M ▹ λ[U],V : B) \/
 (exists s, Γ ⊢ M ▹ !s : A /\ Γ ⊢ M ▹ !s : B) \/
 (exists U, exists V, Γ ⊢ M ▹ Π(U),V : A /\ Γ ⊢ M ▹ Π(U),V : B).
induction 1; intros.
apply pgen_var in H1. destruct H1 as ( _ & A' & ? & ? ).
left. replace A with A'. intuition. eapply fun_item_lift. apply H1. trivial.
(**)
apply pgen_sort in H1. destruct H1 as ( _ & t & ? & ? ).
right; right; left. exists s1; split.
eauto. destruct H2. subst; eauto. eapply typ_pcompat; eauto.
(**)
clear IHtyp1 IHtyp2. apply pgen_pi in H2 as (A'' & B'' & s & t & u & h); decompose [and] h; clear h.
right; right; right. exists A'; exists B'; split. eapply typ_pi; eauto.
destruct H7. subst. apply typ_pi with s t; trivial.
eapply relocate. apply H4. apply H0. eapply relocate. apply H3. apply H1. apply typ_pcompat with !u; intuition.
apply typ_pi with s t; trivial. eapply relocate. apply H4. apply H0. eapply relocate. apply H3. apply H1.
(**)
clear IHtyp1 IHtyp2 IHtyp3.
right; left. apply pgen_la in H3. destruct H3 as (A'' & M'' & D & D'' & s & t &u & h); decompose [and] h; clear h.
exists A'; exists M'; split. eapply typ_la. apply H. trivial. apply H1. trivial.
apply typ_pcompat with (Π(A),D). eapply typ_la. apply H3. eapply relocate. apply H5. apply H0.
apply H6. eapply relocate. apply H4. apply H2. trivial.
(**)
apply pgen_app in H4. destruct H4 as (C & C' & B'' & N'' & s & t & u & h). decompose [and] h; clear h.
left; trivial.
(**)
apply pgen_app in H4. destruct H4 as (C & C' & B'' & N'' & s & t & u & h). decompose [and] h; clear h.
left; trivial.
(**)
destruct (IHtyp1 P B0 H1) as [ | [ | [ | ] ] ]. left; eauto.
destruct H2 as (U & V & ? & ?). right; left. exists U; exists V; split. eapply typ_pcompat with A; eauto. trivial.
destruct H2 as ( t & ? & ?). right; right; left. exists t; split. eapply typ_pcompat with A; eauto. trivial.
destruct H2 as (U & V & ? & ?). right; right; right. exists U; exists V; split. eapply typ_pcompat with A; eauto. trivial.
(**)
destruct (IHtyp1 P B0 H1) as [ | [ | [ | ] ] ]. left; eauto.
destruct H2 as (U & V & ? & ?). right; left. exists U; exists V; split. eapply typ_pcompat with B; eauto. trivial.
destruct H2 as ( t & ? & ?). right; right; left. exists t; split. eapply typ_pcompat with B; eauto. trivial.
destruct H2 as (U & V & ? & ?). right; right; right. exists U; exists V; split. eapply typ_pcompat with B; eauto. trivial.
Qed.


Lemma eq_subst_gen :  forall A Γ M M' , A::Γ ⊢ M  ≡' M'  -> forall N N' N'' , Γ ⊢ N ▹▹ N' : A  -> 
Γ ⊢ N'' ▹▹ N' : A  ->   Γ ⊢  M[ ← N ] ≡' M' [ ← N'' ] .
intros. apply Confluence in H as (P & q & q' & ? & ?).
apply typ_peq_trans with (P[ ← N']). apply reds_to_conv with q. change !q with (!q [ ← N]).
eapply reds_subst_gen. apply H. apply H0. apply typ_peq_sym.
apply reds_to_conv with q'. change !q' with (!q' [ ← N'']).
eapply reds_subst_gen. apply H2. apply H1.
Qed.


Lemma ErasedTermConfluence : forall M N Γ M' A N' B, strip M = strip N ->  Γ ⊢ M ▹ M' : A -> Γ ⊢ N ▹ N' : B -> 
  exists P,  Γ ⊢ M ▹▹ P : A /\ Γ ⊢ N ▹▹ P : B.
induction M; intros.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply red_refl_lt in H1. apply red_refl_lt in H0. exists #v0; intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply red_refl_lt in H1. apply red_refl_lt in H0. exists !s0; intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
rename M1 into P. rename M3 into Q. rename M2 into D.
rename N1 into P'. rename N3 into Q'. rename N2 into D'.
apply pgen_app in H0. destruct H0 as (C & C1 & D1 & Q1 & s1 & t1  & u1 & h). decompose [and] h ; clear h.
apply pgen_app in H1. destruct H1 as (C' & C'1 & D'1 & Q'1 & s2 & t2  & u2 & h). decompose [and] h ; clear h.
assert (exists PP, Γ ⊢ P ▹ PP : Π(C),D). destruct H8. destruct H8 as (P'' & ? & ?). exists P''; trivial.
destruct H8 as (K & K' & -> & ? & ?). exists (La C1 K'). econstructor. apply H. trivial. apply H0. trivial.
assert (exists PP', Γ ⊢ P' ▹ PP' : Π(C'),D'). destruct H13. destruct H13 as (P'' & ? & ?). exists P''; trivial.
destruct H13 as (K & K' & -> & ? & ?). exists (La C'1 K'). econstructor. apply H1. trivial. apply  H7. trivial.
destruct H12 as (PP & ?). destruct H14 as (PP' & ?). clear H8 H13.
destruct (IHM3 Q' Γ Q1 C Q'1 C'  H2 H5 H10) as (RQ & ? & ? ). clear IHM3.
destruct (IHM1 P' Γ PP (Pi C D) PP' (Pi C' D') H3 H12 H14) as (RP & ? & ? ). clear IHM1.
destruct (weak_type_shape Γ RP RP (Π(C),D)) with (P := RP) (B := Π(C'),D') as [ | [ | [ ] ] ].
apply typ_reds_to_red in H15 as ( _ & ? ); trivial. apply typ_reds_to_red in H16 as ( _ & ? ); trivial.

destruct (PiInj Γ C D C' D' H17) as (? & ?). apply Confluence in H19 as (Z & d1 & d2 & ? & ?).
exists (App RP Z RQ); split. 
apply reds_typ_pcompat with (D [ ← Q]); trivial. eapply reds_App. apply  H15. trivial. apply H19.
apply reds_typ_pcompat with (D' [ ← Q']); trivial.  eapply reds_App. apply H16. trivial. eapply conv_in_env_reds. apply H20. eauto.

destruct H17 as (U & V & ? & ?). destruct (pgen_la Γ U V (λ[U],V) (Π(C),D)) as (U' & V' & K & K' & s & t & u & h).
apply red_refl_rt in H17; trivial. decompose [and] h; clear h. injection H23; intros; subst; clear H23.
destruct (pgen_la Γ U' V' (λ[U'],V') (Π(C'),D')) as (U'' & V'' & L & L'' & s' & t' & u' & h).
apply red_refl_rt in H18; trivial. decompose [and] h; clear h. injection H28; intros; subst; clear H28.
destruct (PiInj Γ U'' K C D H25) as ( ? & ?). destruct (PiInj Γ U'' L C' D' H30) as ( ? & ?).
exists (V''[← RQ]); split.
apply reds_typ_pcompat with (D [ ← Q]); trivial. eapply typ_reds_trans. eapply reds_App.
eapply typ_reds_trans. apply H15. constructor. apply H17.  constructor; apply red_refl_lt in H5; apply H5.  constructor; apply red_refl_lt in H0; apply H0.
destruct (Confluence (U''::Γ) K D H29) as (E & a & b & ? & ?). eapply typ_reds_trans.
eapply reds_App. constructor; apply red_refl_rt in H17; apply H17.  apply H8. eapply conv_in_env_reds. apply H34. eauto. constructor.
apply typ_pcompat with (E [← RQ]). eapply typ_beta. apply H19. apply H21. eapply typ_reds_relocate in H33. apply typ_reds_to_red in H33 as ( _ & ?). apply H33.
apply H22. apply typ_pcompat with K. trivial. eapply reds_to_conv; apply H33. apply typ_pcompat with C. apply typ_reds_to_red in H8 as (_  & ?); trivial. eauto.
apply typ_peq_sym. apply reds_to_conv with b. change !b with (!b[← Q]). eapply reds_subst_gen. apply H34.
apply reds_typ_pcompat with C; eauto.
apply reds_typ_pcompat with (D' [ ← Q']); trivial. eapply typ_reds_trans. eapply reds_App.
eapply typ_reds_trans. apply H16. constructor. apply H18.  constructor; apply red_refl_lt in H10; apply H10.  constructor; apply red_refl_lt in H7; apply H7.
destruct (Confluence (U''::Γ) L D' H32) as (E & a & b & ? & ?). eapply typ_reds_trans.
eapply reds_App. constructor; apply red_refl_rt in H18; apply H18.  apply H13. eapply conv_in_env_reds. apply H34. eauto. constructor.
apply typ_pcompat with (E [← RQ]). eapply typ_beta. apply H23. apply H26. eapply typ_reds_relocate in H33. apply typ_reds_to_red in H33 as ( _ & ?). apply H33.
apply H27. apply typ_pcompat with L. trivial. eapply reds_to_conv; apply H33. apply typ_pcompat with C. apply typ_reds_to_red in H8 as (_  & ?); trivial. eauto.
apply typ_peq_sym. apply reds_to_conv with b. change !b with (!b[← Q']). eapply reds_subst_gen. apply H34. apply reds_typ_pcompat with C'; eauto.

destruct H17 as (z & ? & ?). apply red_refl_rt in H17. apply pgen_sort in H17 as ( ? & ? & ? & ?).
destruct H20. discriminate. apply peq_not_Pi_sort in H20; elim H20.

destruct H17 as (U & V & ? & ?). apply red_refl_rt in H17. apply pgen_pi in H17 as ( U' & V' & s & t & u & h).
decompose [and] h; clear h. destruct H23. discriminate. apply peq_not_Pi_sort in H22; elim H22.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply pgen_pi in H0. destruct H0 as (M1' & M2' & s1 & t1 & u1 & h). decompose [and] h; clear h.
apply pgen_pi in H1. destruct H1 as (N1' & N2' & s2 & t2 & u2 & h). decompose [and] h; clear h.
destruct (IHM1 N1 Γ M1' !s1 N1' !s2 H3 H4 H8) as (R1 &  ? & ?).
assert (Γ ⊢ M1 ≡' N1). apply typ_peq_trans with R1. apply reds_to_conv in H10; trivial. apply reds_to_conv in H12; intuition.
destruct (IHM2 N2 (M1::Γ) M2' !t1 N2' !t2 H2 H0 ) as (R2 & ? & ?).
eapply conv_in_env. apply H6. eauto. exists (Pi R1 R2); split.
destruct H7. subst.  eapply reds_Pi. apply H10. apply H14. trivial.
apply reds_typ_pcompat with !u1. eapply reds_Pi.  apply H10. apply H14. trivial. intuition.
destruct H11. subst.  eapply reds_Pi. apply H12. eapply conv_in_env_reds. apply H15. eauto. trivial.
apply reds_typ_pcompat with !u2. eapply reds_Pi. apply H12. eapply conv_in_env_reds. apply H15. eauto. trivial. intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply pgen_la in H0. destruct H0 as (M1' & M2' & D & D' & s1 & t1 & u1 & h). decompose [and] h; clear h.
apply pgen_la in H1. destruct H1 as (N1' & N2' & D2 & D2' & s2 & t2 & u2 & h). decompose [and] h; clear h.
destruct (IHM1 N1 Γ M1' !s1 N1' !s2 H3 H4 H9) as (R1 & ? & ? ).
assert (Γ ⊢ M1 ≡' N1). apply typ_peq_trans with R1. apply reds_to_conv in H12; trivial. apply reds_to_conv in H14; intuition.
destruct (IHM2 N2 (M1::Γ) M2' D N2' D2 H2) as (R2 & ? & ? ); trivial.
eapply conv_in_env. apply H7. eauto. exists (La R1 R2); split.
apply reds_typ_pcompat with (Π (M1), D); trivial. eapply reds_La.  apply H12. trivial. apply H5. apply H.
apply reds_typ_pcompat with (Π (N1), D2); trivial. eapply reds_La. apply H14. eapply conv_in_env_reds.  apply H17. eauto.
apply H10. apply H1.
Qed.



Lemma ErasedTypeConversion : forall A B Γ A' s B' t, strip A = strip B -> Γ ⊢ A ▹ A' : !s -> Γ ⊢ B ▹ B' : !t ->
  Γ ⊢ A ≡' B.
intros.
destruct (ErasedTermConfluence A B Γ A' !s B' !t H H0 H1) as ( P & ?&  ?).
apply typ_peq_trans with P. apply reds_to_conv in H2; trivial. apply reds_to_conv in H3; intuition.
Qed.

Lemma L43_ : forall Γ Γ', strip_env Γ = strip_env Γ' -> wf Γ -> wf Γ' -> env_conv Γ Γ'.
induction Γ; intros. destruct Γ'; simpl in H.
intuition. discriminate. destruct Γ'; simpl in *. discriminate.
injection H; intros; subst; clear H. eapply c_trans with (a::Γ').
apply env_conv_cons. inversion H0; subst; clear H0. econstructor. apply red_refl_lt in H4; apply H4.
inversion H1; inversion H0; subst; clear H0 H1. apply wf_from_typ in H4. apply wf_from_typ in H7. intuition.
apply env_conv_cons.  inversion H1; inversion H0; subst; clear H0 H1.
eapply ErasedTypeConversion. trivial. eapply conv_in_env. apply H7. apply IHΓ. trivial. apply wf_from_typ in H7; trivial.
apply wf_from_typ in H4; trivial. apply H4.  inversion H1; inversion H0; subst; clear H0 H1.
apply wf_from_typ in H4. apply wf_from_typ in H7. intuition.
Qed.


Lemma ErasedContextSwitch : forall Γ M N T, Γ ⊢ M ▹ N : T -> forall  Γ', wf Γ' -> strip_env  Γ = strip_env  Γ' -> Γ' ⊢ M ▹ N : T.
induction 1; intros.
apply conv_in_env with  Γ. intuition. apply L43_; trivial.
(**)
intuition.
(**)
apply typ_pi with s1 s2; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H3; trivial.
(**)
apply typ_la with B' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H4; trivial. eapply IHtyp3. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H4; trivial.
(**)
apply typ_app with A A' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial.
(**)
apply typ_beta with A' B' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial. eapply IHtyp3. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial.
(**)
eauto.
(**)
eauto.
Qed.

Require Import red.

Lemma L33 : forall M N', ut_red.Beta (strip M) N' ->exists N, strip N = N' /\ Beta M N.
induction M; intros; simpl in *.
inversion H. inversion H.
inversion H; subst; clear H. destruct M1; simpl in *; try discriminate.
injection H1; intros; subst; clear H1.
exists ( M1_2 [ ← M3]); split. rewrite strip_subst. trivial. intuition.
destruct (IHM1 y H3) as (n & ? & ?). exists (App n M2 M3); split. simpl. subst. trivial.
intuition. destruct (IHM3 y H3) as (n & ? & ?). exists (App M1 M2 n); split. simpl. subst. trivial.
intuition. inversion H; subst; clear H. 
destruct (IHM2 y H3) as (n & ? & ?). exists (Pi M1 n); split. simpl. subst. trivial.
intuition. destruct (IHM1 B H3) as (n & ? & ?). exists (Pi n M2); split. simpl. subst. trivial.
intuition.  inversion H; subst; clear H. 
destruct (IHM2 y H3) as (n & ? & ?). exists (La M1 n); split. simpl. subst. trivial.
intuition. destruct (IHM1 B H3) as (n & ? & ?). exists (La n M2); split. simpl. subst. trivial.
intuition.
Qed.

Lemma L33' : forall M N', ut_red.Betas (strip M) N' ->exists N, strip N = N' /\ Betas M N.
intros. remember (strip M) as MM. revert M HeqMM. induction H; intros; subst.
exists M; intuition. apply L33 in H as (N & ? & ?).
exists N; intuition. destruct (IHBetas1 M ) as (N & ? & ?); trivial.
destruct (IHBetas2 N) as (NN & ?& ?). intuition.
exists NN; intuition. eauto.
Qed.

Lemma FromPTS_to_TPOSR : (forall Γ  M A , ut_typ.typ Γ M A -> exists Γ', exists M', exists A', strip_env Γ' = Γ /\ 
  strip M' = M /\ strip A' = A /\ Γ' ⊢ M' ▹ M' : A') /\
        (forall Γ , ut_typ.wf Γ -> exists Γ', strip_env Γ' = Γ /\ wf Γ').
apply ut_typ.typ_induc; intros.
destruct H as (Γ' & ? & ?). exists Γ'; exists !s; exists !t; intuition.
(**)
destruct H as (ΓΓ & ? & ?). assert (exists AA, AA ↓ v ⊂ ΓΓ /\ A = strip AA).
clear w H0. revert ΓΓ A v H i. induction Γ; intros. destruct i as ( a & ? &?).
inversion H1. destruct ΓΓ; simpl in H. discriminate. injection H; intros; subst; clear H.
destruct i as (a &? & ?). inversion H0; subst; clear H0. exists (lift_rec 1 0 t).
split. exists t. intuition. rewrite strip_lift; trivial. 
destruct (IHΓ ΓΓ (ut_term.lift_rec (S n) 0 a) n) as (B & ?& ?). trivial.
exists a; intuition. exists (lift_rec 1 0 B). split. destruct H as (b & ?& ?).
exists b. subst. rewrite lift_lift; intuition. rewrite strip_lift. rewrite <- H0.
rewrite ut_term.lift_lift. trivial.
destruct H1 as (B &? & ?). exists ΓΓ; exists #v; exists B; simpl; intuition.
(**)
destruct H as (Γa & A' & ? & ? & ? & ? & ?). destruct x; simpl in H2; try discriminate.
injection H2; intros; subst; clear H2.
destruct H0 as (Γb & B' & ? & ? & ? & ? & ?). destruct x; simpl in H1; try discriminate.
injection H1; intros; subst; clear H1.
exists Γa ; exists (Pi A' B'); exists !u; simpl; intuition. econstructor.
apply r. trivial. eapply ErasedContextSwitch. apply H2. econstructor. eapply H3. simpl; trivial.
(**)
destruct H as (Γa & Ma & ? & ? & ?& ? & ?). destruct x; simpl in H3; try discriminate.
injection H3; intros; subst; clear H3. destruct H0 as (Γb & Mb & ? & ? & ? & ? & ?).
destruct x; simpl in H2; try discriminate. injection H2; intros; subst; clear H2.
destruct H1 as (Γm & M' & B' & ? & ?& ? &?). destruct Γb; simpl in H. discriminate.
injection H; intros; subst; clear H. destruct Γm; simpl in H0. discriminate.
injection  H0; intros; subst; clear H0.
exists Γa; exists (La Ma M'); exists (Pi Ma Mb); simpl; intuition. econstructor.
apply r. trivial. eapply ErasedContextSwitch. apply H3. econstructor. apply H4. simpl. rewrite H6. rewrite H7. trivial.
destruct (typ_wf (t3 :: Γm)  M' M' B' H5). destruct H0; subst. simpl in H2; destruct Mb; try discriminate.
simpl in H2. injection H2; intros; subst; clear H2. eapply ErasedContextSwitch. apply H5.  econstructor. apply H4.
simpl. rewrite H1; rewrite H; trivial. destruct H0 as ( x & ?).
eapply ErasedContextSwitch. apply typ_pcompat with B'. apply H5. eapply ErasedTypeConversion. trivial. apply H0. 
eapply ErasedContextSwitch. apply H3. apply wf_from_typ in H0; trivial. simpl. rewrite H7; rewrite H1; rewrite H6; rewrite H; trivial.
econstructor. apply H4. simpl. rewrite H1; rewrite H; trivial.
(**)
destruct H as (Γm & Mm & Tm & ? & ? & ? &?). destruct Tm; simpl in *; try discriminate. 
injection H2; intros; subst; clear H2. destruct H0 as (Γn & Mn & Tn &? & ? & ?& ?).
exists Γm; exists (App Mm Tm2 Mn); exists (Tm2  [ ← Mn]); intuition.
subst. simpl. trivial. rewrite strip_subst. subst. trivial.
assert (exists u, Γm ⊢ Π (Tm1),Tm2 ▹ Π(Tm1),Tm2 : !u). apply typ_wf in H3.
destruct H3. destruct H3 ; discriminate. trivial. destruct H4 as (u& ?).
apply pgen_pi in H4 as (Tm1' & Tm2' & s1 & s2 & s3 & h); decompose [and] h; clear h.
injection H7; intros; subst; clear H7.
econstructor. apply H4. apply H6. trivial. trivial. apply typ_pcompat with Tn. eapply ErasedContextSwitch.
apply H2. apply wf_from_typ in H6; trivial. trivial. apply typ_wf in H2. destruct H2 as [ [ s ?] | [s ?] ].
subst. destruct Tm1'; simpl in H1; try discriminate. injection H1; intros; subst; clear H1.
econstructor. apply H6. eapply ErasedTypeConversion. trivial. eapply ErasedContextSwitch. apply H0. apply wf_from_typ in H6; trivial.
trivial. apply H6.
(**)
rename a into M.
destruct H as (Γ' & M' & A' & ? & ? & ? & ?). destruct H0 as (Γ2 & B' & Tb & ? & ?& ?& ?).
destruct Tb; simpl in H5; try discriminate. injection H5; intros; subst; clear H5.
destruct (typ_wf Γ' M' M' A' H3). destruct H as (a & ?). subst; simpl in b.
apply conv_to_sort in b.
apply L33' in b. destruct b as ( n & ? & ?). destruct n; simpl in H; try discriminate.
injection H; intros; subst; clear H.
exists Γ'; exists M' ; exists B'; intuition. apply typ_pcompat with !a.
trivial. apply typ_peq_sym. apply reds_to_conv with s.
apply SR_trans' with B'; trivial. eapply ErasedContextSwitch. apply H6. apply wf_from_typ in H3; trivial. trivial.
destruct H as (sA' & ?). apply Betac_confl in b as (C & ?& ?).
apply L33' in H1 as (C0 & ? & ?). apply L33' in H2 as (C1 & ? & ?).
exists Γ'; exists M'; exists B'; intuition. eapply typ_pcompat with A'.
trivial. assert (Γ' ⊢ A' ▹▹ C0 : !sA').   apply SR_trans' with A'. trivial. trivial.
assert (Γ' ⊢ B' ▹▹ C1 : !s).   apply SR_trans' with B'. trivial. eapply ErasedContextSwitch.
apply H6. apply wf_from_typ in H3; trivial. trivial. apply typ_peq_trans with C0.
apply reds_to_conv with sA'; trivial.  apply typ_peq_trans with C1.
eapply ErasedTypeConversion. rewrite H1. rewrite H2. trivial. apply typ_reds_to_red in H7 as (_ & ?).
apply H7. apply typ_reds_to_red in H8 as (_ & ?). apply H8.  apply typ_peq_sym.
apply reds_to_conv with s; trivial.
(** wf **)
exists nil; simpl; intuition.
(**)
destruct H as (Γ' & M' & A' & ? & ? & ? & ?).
destruct A'; simpl in H1; try discriminate. injection H1; intros; subst; clear H1.
exists (M'::Γ'); simpl; intuition. econstructor. apply H2.
Qed.


