Require Import Peano_dec.
Require Import Compare_dec.
Require Import Lt.
Require Import Omega.

Require Import base.
Require Import ut_term.
Require Import ut_red.
Require Import ut_env.
Require Import ut_typ.
Require Import term.
Require Import env.
Require Import typ_annot.
Require Import List.
Require Import strip.

Open Scope Typ_scope.


Lemma reds_Pi : forall Γ A A' s, Γ ⊢ A  ▹▹ A' : !s -> forall B B' t u, A::Γ ⊢ B  ▹▹ B' :!t ->
  Rel s t u ->  Γ ⊢ Π (A), B ▹▹ Π (A'), B' : !u.
assert (forall Γ A A' S, Γ ⊢ A  ▹▹ A' : S -> forall s B B' t u, S = !s -> A::Γ ⊢ B  ▹ B' :!t ->
  Rel s t u ->  Γ ⊢ Π (A), B ▹▹ Π (A'), B' : !u).
induction 1; intros; subst. constructor. eapply typ_pi; eauto. 
apply typ_reds_trans with (Pi t B). eapply IHtyp_reds1. reflexivity. apply red_refl_lt in H2.
apply H2. trivial. eapply IHtyp_reds2. reflexivity. eapply conv_in_env. apply H2.
apply reds_to_conv in H. eauto. trivial.
assert (forall Γ' B B' T, Γ' ⊢ B  ▹▹ B' : T -> forall Γ A A' s t u, T = !t -> Γ' = A::Γ -> 
  Γ ⊢ A  ▹ A' :!s ->   Rel s t u ->  Γ ⊢ Π (A), B ▹▹ Π (A'), B' : !u). clear H.
induction 1; intros; subst. constructor. eapply typ_pi; eauto.
apply typ_reds_trans with (Pi A t). eapply IHtyp_reds1. reflexivity. trivial. apply red_refl_lt in H3; apply H3.
trivial. eapply IHtyp_reds2. reflexivity. trivial. apply H3. trivial.
intros. apply typ_reds_trans with (Pi A B'). eapply H0. apply H2. reflexivity. trivial. 
apply typ_reds_to_red in H1 as (?& ?). apply red_refl_lt in H1; apply H1. trivial.
eapply H. apply H1. reflexivity. apply typ_reds_to_red in H2 as (?& ?). apply red_refl_lt in H4.
apply H4. trivial.
Qed.


Lemma reds_La : forall Γ A A' s, Γ ⊢ A  ▹▹ A' : !s -> forall M M' B B' t u, A::Γ ⊢ M ▹▹ M' :B ->
  A::Γ ⊢ B ▹ B' : !t ->  Rel s t u ->  Γ ⊢  λ[A], M ▹▹ λ[A'], M' :Π (A), B .
assert (forall Γ A A' S, Γ ⊢ A  ▹▹ A' : S ->  forall M M' B B' s t u,S = !s ->  A::Γ ⊢ M ▹ M' :B ->
  A::Γ ⊢ B ▹ B' : !t ->  Rel s t u ->  Γ ⊢  λ[A], M ▹▹ λ[A'], M' :Π (A), B) .
induction 1; intros; subst. constructor. econstructor. apply H3. trivial. apply H2. trivial.
apply typ_reds_trans with (La t M). eapply IHtyp_reds1. reflexivity. apply red_refl_lt in H2; trivial.
apply H3. apply H4. eapply typ_reds_relocate. eapply IHtyp_reds2. reflexivity.
eapply conv_in_env. apply H2. apply reds_to_conv in H; eauto.
eapply conv_in_env. apply H3. apply reds_to_conv in H; eauto. apply H4.
eapply typ_reds_to_red. eapply IHtyp_reds1. reflexivity. apply red_refl_lt in H2; apply H2. apply H3. apply H4.
assert (forall Γ' M M' B, Γ' ⊢ M  ▹▹ M' : B -> forall Γ A A' B' s t u, Γ' = A::Γ -> 
  Γ ⊢ A  ▹ A' :!s ->  A::Γ ⊢ B ▹ B' : !t ->  Rel s t u ->  Γ ⊢  λ[A], M ▹▹ λ[A'], M' :Π (A), B) . clear H.
induction 1; intros; subst.
constructor. econstructor. apply H3. trivial. apply H2. trivial.
apply typ_reds_trans with (La A t). eapply IHtyp_reds1. trivial. apply red_refl_lt in H2; apply H2.
apply H3. apply H4. eapply IHtyp_reds2. trivial. apply H2. apply H3. apply H4.
intros. apply typ_reds_trans with (La A M'). eapply H0. apply H2. trivial. apply typ_reds_to_red in H1 as (? & ?).
apply H1. apply H3. apply H4. eapply H. apply H1. reflexivity. apply typ_reds_to_red in H2 as (? & ?).
apply H5. apply H3. apply H4.
Qed.


Lemma reds_subst : forall A Γ M M' B , A::Γ ⊢ M  ▹▹ M' : B -> forall N N' , Γ ⊢ N ▹ N' : A -> 
   Γ ⊢  M[ ← N ] ▹▹ M' [ ← N' ] : B[ ← N ].
intros until 1.  remember (A::Γ) as ΓΓ. revert A Γ HeqΓΓ. induction H; intros; subst.
constructor. eapply subst_gen. apply H. constructor. trivial.
eapply typ_reds_trans2. eapply IHtyp_reds1. reflexivity. apply H1.
eapply IHtyp_reds2. reflexivity. apply red_refl_rt in H1; trivial.
Qed.

Lemma reds_subst_gen : forall A Γ M M' B , A::Γ ⊢ M  ▹▹ M' : B -> forall N N' , Γ ⊢ N ▹▹ N' : A -> 
   Γ ⊢  M[ ← N ] ▹▹ M' [ ← N' ] : B[ ← N ].
intros. revert M M' B H. induction H0; intros.
eapply reds_subst. apply H0. trivial.
eapply typ_reds_trans2. eapply IHtyp_reds1. apply H.
eapply IHtyp_reds2. constructor. apply typ_reds_to_red in H as ( _ & ?).
apply H.
Qed.


Lemma eq_subst_gen :  forall A Γ M M' , A::Γ ⊢ M  ≡' M'  -> forall N N' N'' , Γ ⊢ N ▹▹ N' : A  -> 
Γ ⊢ N'' ▹▹ N' : A  ->   Γ ⊢  M[ ← N ] ≡' M' [ ← N'' ] .
intros. apply Confluence in H as (P & q & q' & ? & ?).
apply typ_peq_trans with (P[ ← N']). apply reds_to_conv with q. change !q with (!q [ ← N]).
eapply reds_subst_gen. apply H. apply H0. apply typ_peq_sym.
apply reds_to_conv with q'. change !q' with (!q' [ ← N'']).
eapply reds_subst_gen. apply H2. apply H1.
Qed.




Lemma reds_App_ : forall Γ M M' A B , Γ ⊢ M ▹▹ M' : Π(A),B -> forall N N' , Γ ⊢ N ▹▹ N' : A ->
  Γ ⊢ M ·(B) N  ▹▹ M'·(B) N' : B[ ← N].
intros until 1. remember (Pi A  B) as P. revert A B HeqP. induction H; intros; subst.
revert B s t H. induction H0; intros.
destruct (typ_wf Γ s0 t0 (Pi T B) H0). destruct H1 as (? & ?); discriminate.
destruct H1 as (u & ?). apply pgen_pi in H1 as (T' & B'' & t1 & t2 & t3 & h).
decompose [and] h; clear h. injection H4; intros; subst; clear H4.
constructor.  econstructor. apply H1. apply H3. trivial. trivial. trivial.
apply typ_reds_trans with (App s0 B t). eapply IHtyp_reds1. apply red_refl_lt in H; trivial.
apply reds_typ_pcompat with (B [← t]). eapply IHtyp_reds2. trivial.
apply typ_wf in H. destruct H. destruct H as (? & ?); discriminate. destruct H as (s3 & ?).
apply pgen_pi in H as (T' & B'' & t1 & t2 & t3 & h). decompose [and] h; clear h.
injection H2; intros; subst; clear H2. apply typ_peq_sym.
apply reds_to_conv with t2. change !t2 with (!t2 [← s]).
eapply reds_subst_gen. constructor. apply H0. trivial.
eapply typ_reds_trans2. eapply IHtyp_reds1. reflexivity. apply H1.
eapply IHtyp_reds2. reflexivity. apply typ_reds_to_red in H1 as (_ & ?).
constructor. trivial.
Qed.

Lemma reds_App__ : forall Γ M M' A B , Γ ⊢ M ▹ M' : Π(A),B -> forall B' s N N' , Γ ⊢ N ▹ N' : A ->
 A::Γ ⊢ B ▹▹ B' : !s ->   Γ ⊢ M ·(B) N  ▹▹ M·(B') N : B[ ← N].
intros. revert M M' N N' H H0 . remember (A::Γ) as ΓΓ. remember !s as S.
revert A Γ HeqΓΓ s HeqS. induction H1; intros; subst.
constructor. destruct (typ_wf Γ0 M M' (Pi A s) H0). destruct H2 as ( ?& ?); discriminate.
destruct H2 as (x & ?). apply pgen_pi in H2 as (A' & s' & s1 & s2 & s3 & h). decompose [and] h;clear h.
injection H5; intros; subst; clear H5.
econstructor. apply H2. apply H4. eapply relocate. apply H3. apply H. apply red_refl_lt with M'; trivial.
apply red_refl_lt with N'; trivial.
eapply typ_reds_trans2. eapply IHtyp_reds1. reflexivity. reflexivity. apply H. apply H0.
eapply IHtyp_reds2. reflexivity. reflexivity. apply typ_pcompat with (Pi A s). apply H.
apply typ_wf in H  as [ | ]. destruct H ; discriminate. destruct H as (x & ?).
apply pgen_pi in H as (A'' & s'' & a & b& c & h); decompose [and] h; clear h.
eapply WPiFun.  apply reds_to_conv in H1_. trivial. apply H. apply H2.
apply H0.
Qed.

Lemma reds_App : forall Γ M M' A B , Γ ⊢ M ▹▹ M' : Π(A),B -> forall B' s N N' , Γ ⊢ N ▹▹ N' : A ->
  A::Γ ⊢ B ▹▹ B' : !s -> Γ ⊢ M ·(B) N  ▹▹ M'·(B') N' : B[ ← N].
intros. eapply typ_reds_trans. eapply reds_App_. apply H. apply H0. 
apply reds_typ_pcompat with (B [ ← N']). eapply reds_App__. 
apply typ_reds_to_red in H as (_ & ?). apply H.
apply typ_reds_to_red in H0 as (_ & ?). apply H0. apply H1.
apply typ_reds_to_red in H as (_ & ?). apply typ_wf in H. destruct H. destruct H ; discriminate.
destruct H. apply pgen_pi in H as (A'' & B'' & s1 & t1 & u1 & h). decompose [and] h; clear h.
apply typ_peq_sym. apply reds_to_conv with t1. change !t1 with (!t1 [ ← N]).
eapply reds_subst_gen. constructor. apply red_refl_lt in H2; apply H2. trivial.
Qed.


Lemma list_destr2 : forall (A:Type) (l:list A), { l  = nil  } + { exists a, exists l', l = l'++a::nil }.
intros A l. induction l.
left; trivial. right. destruct IHl. subst. exists a; exists nil; simpl; trivial.
destruct e as (b & k & ->). exists b; exists (a::k). rewrite app_comm_cons. trivial.
Qed.

Lemma env_subst_tail : forall l n a t, (l++a::nil)[[ n ← t]] = (l[[ n ← t ]] ) ++ (a[ length l + n ← t]) :: nil.
induction l; simpl; intros. trivial. rewrite IHl. rewrite plus_n_Sm. trivial.
Qed.

Lemma toto_: forall n l Γ t T, n = length l -> sub_in_env Γ t T n (rev l ++ T ::  Γ) (rev (l [[0 ← t]]) ++Γ).
induction n; intros. destruct l; simpl in *. constructor. discriminate.
destruct (list_destr2 Term l). subst; discriminate. destruct e as (b&  k & ->).
 rewrite app_length in H. simpl in H. rewrite <- plus_n_Sm in H. rewrite <- plus_n_O in H. injection H; intros;subst; clear H.
replace (rev (k++b::nil)) with (b::rev k). replace (rev (k++b :: nil [[ 0 ← t]])) with ((b[ (length k) ← t ]):: (rev (k [[ 0  ← t ]]))).
rewrite <- 2! app_comm_cons. constructor. apply IHn. trivial.
rewrite env_subst_tail. rewrite distr_rev. simpl. rewrite <- plus_n_O. trivial.
rewrite distr_rev. simpl. trivial.
Qed.

Lemma toto: forall l Γ t T, sub_in_env Γ t T (length l) (rev l ++ T ::  Γ) (rev (l [[0 ← t]]) ++Γ).
intros. apply toto_. trivial.
Qed.



Lemma Ts_Shape: forall Γ M N A,  Γ ⊢ M ▹ N : A -> forall P B, Γ ⊢ M ▹ P : B -> Ts M ->
 (exists s, exists l, exists a, exists b, 
      Γ ⊢ M ▹▹ Tels' l !s : A /\ Γ ⊢ M ▹▹ Tels' l !s : B /\
     ((l = nil /\ A = !a) \/ Γ ⊢ A ≡' Tels l !a ) /\  ((l = nil /\ B = !b) \/ Γ ⊢ B ≡' Tels l !b ) /\
     (rev l ++ Γ) ⊢ !s ▹ !s : !a /\ (rev l ++ Γ) ⊢ !s ▹ !s : !b ) \/ 
 (exists K, exists L,  exists l, exists a, exists b, Γ ⊢ M ▹▹ Tels' l (Π(K),L) : A /\  Γ ⊢ M ▹▹ Tels' l (Π(K),L) : B /\
     ((l = nil /\ A = !a) \/ Γ ⊢ A ≡' Tels l !a ) /\   ((l = nil /\ B = !b) \/ Γ ⊢ B ≡' Tels l !b ) /\
     (rev l ++ Γ)  ⊢ Π(K),L ▹ Π(K),L : !a /\ (rev l ++ Γ)  ⊢ Π(K),L ▹ Π(K),L : !b ) .
induction 1; intros. 
(**)
inversion H2.
(**) clear H2. apply pgen_sort in H1. destruct H1 as (? & t1 & ? & ?).
left. exists s1; exists nil; exists s2; exists t1; simpl; intuition.
subst. intuition. apply reds_typ_pcompat with !t1; intuition.
(**)
clear H3. apply pgen_pi in H2 as (A'' & B'' & u & v & w & h). decompose [and] h; clear h.
right. destruct (ChurchRosser  Γ A A' !s1 H0 A'' !u H4) as ( RA & ? & ? & ?& ?).
destruct (ChurchRosser  (A::Γ) B B' !s2 H1 B'' !v H3) as ( RB & ? & ? & ?& ?).
exists RA; exists RB; exists nil; exists s3; exists w; simpl; repeat split. eapply reds_Pi.
eapply typ_reds_trans. constructor. apply H0. constructor. trivial.
eapply typ_reds_trans. constructor. apply H1. constructor. trivial. trivial.
destruct H7. subst. eapply reds_Pi. eapply typ_reds_trans. constructor. apply H4. constructor. trivial.
eapply typ_reds_trans. constructor. apply H3. constructor. trivial. trivial. apply reds_typ_pcompat with !w.
eapply reds_Pi. eapply typ_reds_trans. constructor. apply H4. constructor. trivial.
eapply typ_reds_trans. constructor. apply H3. constructor. trivial. trivial. intuition.
intuition. intuition. apply typ_pi with s1 s2; trivial. apply red_refl_rt in H6; trivial. apply red_refl_rt in H11.
eapply conv_in_env. apply H11. apply env_conv_cons. eauto. trivial.
apply typ_pi with u v; trivial. apply red_refl_rt in H8; trivial. apply red_refl_rt in H12.
eapply conv_in_env. apply H12. apply env_conv_cons. eauto. trivial.
(**)
inversion H4; subst; clear H4. clear IHtyp1 IHtyp2. apply pgen_la in H3. destruct H3 as (A'' & M'' & D & D' & u & v & w &h).
decompose [and] h; clear h. destruct (IHtyp3 M'' D H4 H6); clear IHtyp3.
destruct H9 as (s & l & a & b & h); decompose [and] h; clear h. left. exists s; exists (A::l); exists a; exists b; simpl; repeat split.
eapply reds_La. constructor. apply red_refl_lt in H0; apply H0. trivial. apply H1. apply H.
apply reds_typ_pcompat with (Pi A D).
eapply reds_La. constructor. apply red_refl_lt in H5; apply H5. trivial. apply H7. apply H3. trivial.
right. destruct H11. destruct H11; subst. simpl. apply typ_peq_intro with s3. apply typ_pi with s1 s2. trivial.
apply red_refl_lt in H0; trivial. apply red_refl_lt in H1; trivial. eapply WPiFun. trivial. apply H. apply H0.
right. destruct H13. destruct H13; subst. simpl. intuition. apply typ_peq_trans with (Pi A D). intuition.
eapply WPiFun. trivial. apply H. apply H0. simpl; rewrite app_ass; trivial. simpl; rewrite app_ass; trivial.
right. destruct H9 as (K & L & l & a & b & h). decompose [and] h; clear h. exists K; exists L; exists  (A::l); exists a; exists b; simpl; repeat split.
eapply reds_La. constructor. apply red_refl_lt in H0; apply H0. trivial. apply H1. apply H.
apply reds_typ_pcompat with (Pi A D). eapply reds_La. constructor. apply red_refl_lt in H5; apply H5. trivial. apply H7. apply H3.
trivial. right. destruct H11. destruct H11 ; subst; simpl. apply typ_peq_intro with s3. apply typ_pi with s1 s2; trivial.
apply red_refl_lt in H0; trivial. apply red_refl_lt in H1; trivial. eapply WPiFun. trivial. apply H. apply H0.
right. destruct H13. destruct H13 ; subst; simpl. intuition. apply typ_peq_trans with (Pi A D). intuition.
eapply WPiFun. trivial. apply H. apply H0. simpl; rewrite app_ass; trivial. simpl; rewrite app_ass; trivial.
(**)
inversion H5; subst; clear H5. clear IHtyp1 IHtyp2 IHtyp4. apply pgen_app in H4. destruct H4 as (U & U' & B'' & N'' &u & v & w & h).
decompose [and] h; clear h. assert (exists M'', Γ ⊢ M ▹ M'' :  Π (U), B). destruct H11. destruct H10 as (M'' & ? & ?). exists M'';trivial.
destruct H10 as (T & T' & -> & ?& ?). exists (La U' T'). apply typ_la with B'' u v w ;trivial. clear H11.
destruct H10 as (M'' & ?).
destruct (IHtyp3 M'' (Pi U B) H10 H7); clear IHtyp3.
destruct H11 as (s & l& a & b & h); decompose [and] h; clear h. destruct H12. destruct H12; discriminate.
destruct H14. destruct H14; discriminate.
destruct l; simpl in H12,H14. apply eq_typ_to_ut in H12; simpl in H12. apply ut_red.Betac_not_Pi_sort in H12; elim H12.
apply PiInj in H12 as ( ? & ?). apply PiInj in H14 as ( ? & ?).
left. simpl in *. exists s;  exists (l [[0 ← N]]); exists a; exists b; repeat split. 
change !s with (!s [ length l + 0 ← N]). rewrite <- Tels'_subst.
eapply typ_reds_trans. eapply reds_App. apply H11. constructor. apply red_refl_lt in H3;  apply H3.
constructor; apply H1. constructor. apply typ_pcompat with (B'[ ← N]).
apply typ_reds_to_red in H11 as (_ & ?). apply pgen_la in H11 as (? & ? & D & D' & a' & b' & c' & h); decompose [and] h; clear h. 
destruct (sf a') with (t := s2) as (w' & ?). exists b';exists c'; trivial. eapply typ_beta. apply H23.
apply H20. eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_pcompat with D. apply red_refl_lt in H19. trivial. apply PiInj in H24 as ( ?& ?). apply typ_peq_trans with B. trivial.
eapply conv_in_env_peq. eauto.  eauto.  apply typ_pcompat with A. apply red_refl_lt in H3; trivial. trivial.
apply typ_peq_intro2 with s2. change !s2 with (!s2[ ← N] ). eapply subst_gen. apply H1. constructor.
apply red_refl_lt in H3; trivial. eapply reds_typ_pcompat with ( B [ ← N]).
change !s with (!s [ length l + 0 ← N]). rewrite <- Tels'_subst.
eapply typ_reds_trans. eapply reds_App. apply H11. constructor. apply red_refl_lt in H3;  apply H3.
constructor; apply H1. constructor. apply typ_pcompat with (B'[ ← N]).
apply typ_reds_to_red in H11 as (_ & ?). apply pgen_la in H11 as (? & ? & D & D' & a' & b' & c' & h); decompose [and] h; clear h. 
destruct (sf a') with (t := s2) as (w' & ?). exists b';exists c'; trivial. eapply typ_beta. apply H23.
apply H20. eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_pcompat with D. apply red_refl_lt in H19. trivial. apply PiInj in H24 as ( ?& ?). apply typ_peq_trans with B. trivial.
eapply conv_in_env_peq. eauto.  eauto.  apply typ_pcompat with A. apply red_refl_lt in H3; trivial. trivial.
apply typ_peq_intro2 with s2. change !s2 with (!s2[ ← N] ). eapply subst_gen. apply H1. constructor.
apply red_refl_lt in H3; trivial. trivial. right. change !a with (!a[length l+0 ← N]). rewrite <- Tels_subst.
eapply peq_subst. apply H16. apply H3. right.   change !b with (!b[length l+0 ← N]). rewrite <- Tels_subst.
apply typ_peq_trans with (B [ ← N]). intuition. eapply peq_subst. apply H18. apply typ_pcompat with A. apply H3.
eauto. rewrite app_ass in H15. simpl in H15. 
change !s with (!s [length l  ← N]). change !a with (!a [ length l ← N]). eapply subst_gen. apply H15.
apply toto. apply typ_pcompat with A. apply red_refl_lt in H3; trivial. trivial.
rewrite app_ass in H17. simpl in H17.
change !s with (!s [length l  ← N]). change !b with (!b [ length l ← N]). eapply subst_gen. apply H17.
apply toto. apply typ_pcompat with A. apply red_refl_lt in H3; trivial. trivial.

destruct H11 as (K & L &  l & a & b & h); decompose [and] h; clear h. destruct H12. destruct H12; discriminate. 
destruct H14. destruct H14; discriminate. destruct l; simpl in H12,H14.
apply eq_typ_to_ut in H14; simpl in H14. apply ut_red.Betac_not_Pi_sort in H14; elim H14. apply PiInj in H14 as (? & ?).
apply PiInj in H12 as (? & ?). right. exists (K[ length l  ← N ]); exists (L[S (length l ) ← N]); exists (l [[ 0 ← N]]); exists a; exists b; repeat split.
change (Π (K [(length l) ← N]), L [(S (length l)) ← N]) with ((Π (K),L)[length l  ← N]).
replace (length l) with (length l + 0). rewrite <- Tels'_subst. eapply typ_reds_trans.
eapply reds_App. apply H11. constructor. apply red_refl_lt in H3; apply H3. constructor. apply H1.
constructor. apply typ_pcompat with (B'[ ← N]). simpl. apply typ_reds_to_red in H11 as (_ & ?). simpl in H11; apply pgen_la in H11.
destruct H11 as (t' & Tl' & D & D' & t1 & t2 & t3 & h). decompose [and] h; clear h.
destruct (sf t1) with (t :=s2) as ( W & ?). exists t2; exists t3; trivial. eapply typ_beta.
apply H23. apply H20. eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_pcompat with D. apply red_refl_lt in H19; trivial. apply typ_peq_trans with B. apply PiInj in H24 as (?& ?); trivial.
eapply conv_in_env_peq. eauto. eauto. apply typ_pcompat with A. apply red_refl_lt with N'; trivial. trivial.
apply typ_peq_sym. eapply peq_subst.  econstructor. apply H1. apply H3. intuition.
apply reds_typ_pcompat with ( B [ ← N]).
change (Π (K [(length l) ← N]), L [(S (length l)) ← N]) with ((Π (K),L)[length l  ← N]).
replace (length l) with (length l + 0). rewrite <- Tels'_subst. eapply typ_reds_trans.
eapply reds_App. apply H11. constructor. apply red_refl_lt in H3; apply H3. constructor. apply H1.
constructor. apply typ_pcompat with (B'[ ← N]). simpl. apply typ_reds_to_red in H11 as (_ & ?). simpl in H11; apply pgen_la in H11.
destruct H11 as (t' & Tl' & D & D' & t1 & t2 & t3 & h). decompose [and] h; clear h.
destruct (sf t1) with (t :=s2) as ( W & ?). exists t2; exists t3; trivial. eapply typ_beta.
apply H23. apply H20. eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_pcompat with D. apply red_refl_lt in H19; trivial. apply typ_peq_trans with B. apply PiInj in H24 as (?& ?); trivial.
eapply conv_in_env_peq. eauto. eauto. apply typ_pcompat with A. apply red_refl_lt with N'; trivial. trivial.
apply typ_peq_sym. eapply peq_subst.  econstructor. apply H1. apply H3. intuition. trivial.
right. change !a with (!a [length l+0 ← N]). rewrite <- Tels_subst.
eapply peq_subst. apply H18. apply H3. right.  change !b with (!b [length l+0 ← N]).
apply typ_peq_trans with (  B [ ← N]).  intuition. rewrite <- Tels_subst. eapply peq_subst. apply H16. apply typ_pcompat with A.
apply H3. eauto.
change !a with (!a [length l  ← N]). change (Π (K [(length l) ← N]), L [(S (length l)) ← N]) with ((Π (K),L)[length l  ← N]). 
eapply subst_gen. apply H15. simpl; rewrite app_ass; apply toto. apply typ_pcompat with A. apply red_refl_lt in H3;  trivial. trivial.
change !b with (!b [length l  ← N]). change (Π (K [(length l) ← N]), L [(S (length l)) ← N]) with ((Π (K),L)[length l  ← N]). 
eapply subst_gen. apply H17. simpl; rewrite app_ass; apply toto. apply typ_pcompat with A. apply red_refl_lt in H3;  trivial. trivial.
(**)
inversion H5; subst; clear  H5. inversion H7;subst;  clear H7. clear IHtyp1 IHtyp2 IHtyp4.
apply pgen_app in H4. destruct H4 as ( U & U' & B'' & N'' & t1 & t2 & t3 & h). decompose [and] h; clear h.
assert (exists M'', A :: Γ ⊢ M ▹ M'' : B). destruct H11. destruct H10 as (LM & ?& ?). apply pgen_la in H10.
destruct H10 as ( A'' & M'' & D & D' & ?& ?& ?& h); decompose [and] h; clear h. exists M''. apply PiInj in H17 as (? & ?).
apply typ_pcompat with D; trivial. destruct H10 as (T & T' & ? & ?& ?). injection H10;intros;  subst; clear H10.
exists T'; trivial. clear H11. destruct H10 as (M'' & ?).
destruct (IHtyp3 M'' B H10 H6) ; clear IHtyp3. destruct H11 as (s &  l & a & b & h); decompose [and] h; clear h.
left. exists s; exists (l [[0 ← N']]); exists a;exists b; simpl; repeat split. eapply typ_reds_trans. eapply reds_App.
eapply reds_La. constructor. apply H0. apply H11. apply H1. apply H. constructor. apply H3.
constructor. apply H1. constructor.
apply typ_pcompat with (B'[ ← N']). change !s with (!s [ length l + 0 ← N']). rewrite <- Tels'_subst. simpl.
eapply typ_beta. apply H. apply red_refl_rt in H0; apply H0. eapply conv_in_env. apply red_refl_rt in H1; apply H1. 
eauto. apply typ_reds_to_red in H11 as (_ & ?).  apply typ_pcompat with B. eapply conv_in_env. apply H11. eauto.
eapply conv_in_env_peq. eauto. eauto. apply typ_pcompat with A. apply red_refl_rt in H3; trivial. eauto.
apply typ_peq_intro2 with s2. change !s2 with (!s2 [← N]). eapply subst_gen. apply H1. constructor. trivial. apply reds_typ_pcompat with (B[ ← N]). 
eapply typ_reds_trans. eapply reds_App. eapply reds_La. constructor. apply H0. apply H11. apply H1. apply H. constructor. apply H3.
constructor. apply H1. constructor. apply typ_pcompat with (B'[ ← N']). change !s with (!s [ length l + 0 ← N']). rewrite <- Tels'_subst. simpl.
eapply typ_beta. apply H. apply red_refl_rt in H0; apply H0. eapply conv_in_env. apply red_refl_rt in H1; apply H1. 
eauto. apply typ_reds_to_red in H11 as (_ & ?).  apply typ_pcompat with B. eapply conv_in_env. apply H11. eauto.
eapply conv_in_env_peq. eauto. eauto. apply typ_pcompat with A. apply red_refl_rt in H3; trivial. eauto.
apply typ_peq_intro2 with s2. change !s2 with (!s2 [← N]). eapply subst_gen. apply H1. constructor. trivial. trivial.
destruct H12. destruct H12; subst. left; simpl; split; trivial. right. change !a with (!a [ length l + 0 ← N']). rewrite <- Tels_subst.
apply typ_peq_trans with (B [ ← N']).  apply typ_peq_intro with s2. change !s2 with (!s2 [←N]). eapply subst_gen. apply red_refl_lt in H1; apply H1.
constructor. trivial. eapply peq_subst. apply H12. apply red_refl_rt in H3; apply H3. 
destruct H14. destruct H14; subst. right. simpl. intuition.  right. change !b with (!b [ length l + 0 ← N']). rewrite <- Tels_subst.
apply typ_peq_trans with (B [ ← N']).  apply typ_peq_trans with (B [ ← N]). intuition. apply typ_peq_intro with s2.
change !s2 with (!s2 [←N]). eapply subst_gen. apply red_refl_lt in H1; apply H1. constructor. trivial.
eapply peq_subst. apply H14. apply red_refl_rt in H3; apply H3. 
change !s with (!s [length l  ← N']). change !a with (!a [ length l ← N']). eapply subst_gen. apply H15.
apply toto. apply red_refl_rt in H3; trivial.
change !s with (!s [length l  ← N']). change !b with (!b [ length l ← N']). eapply subst_gen. apply H17.
apply toto. apply red_refl_rt in H3; trivial.


right. destruct H11 as (K & L &  l& a & b & h); decompose [and] h; clear h.  
exists (K[ length l  ← N' ]); exists (L[S (length l ) ← N']); exists (l [[ 0 ← N']]); exists a; exists b; repeat split.
change (Π (K [(length l) ← N']), L [(S (length l)) ← N']) with ((Π (K),L)[length l  ← N']).
replace (length l) with (length l + 0). rewrite <- Tels'_subst. eapply typ_reds_trans.
eapply reds_App. eapply reds_La. constructor. apply H0. apply H11. apply H1. apply H. constructor. apply H3.
constructor. apply H1. constructor. apply typ_pcompat with (B'[ ← N' ]). eapply typ_beta.
apply H. apply red_refl_rt in H0; apply H0.  eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_reds_to_red in H11 as (_ & ?). eapply conv_in_env. apply typ_pcompat with B. apply H11.
eauto. eauto. apply typ_pcompat with A. apply red_refl_rt in H3; trivial. eauto.
apply typ_peq_intro2 with s2. change !s2 with (!s2 [← N]). eapply subst_gen. apply H1. constructor. trivial. intuition.
apply reds_typ_pcompat with (B [← N]).
change (Π (K [(length l) ← N']), L [(S (length l)) ← N']) with ((Π (K),L)[length l  ← N']).
replace (length l) with (length l + 0). rewrite <- Tels'_subst. eapply typ_reds_trans.
eapply reds_App. eapply reds_La. constructor. apply H0. apply H11. apply H1. apply H. constructor. apply H3.
constructor. apply H1. constructor. apply typ_pcompat with (B'[ ← N' ]). eapply typ_beta.
apply H. apply red_refl_rt in H0; apply H0.  eapply conv_in_env. apply red_refl_rt in H1; apply H1. eauto.
apply typ_reds_to_red in H11 as (_ & ?). eapply conv_in_env. apply typ_pcompat with B. apply H11.
eauto. eauto. apply typ_pcompat with A. apply red_refl_rt in H3; trivial. eauto.
apply typ_peq_intro2 with s2. change !s2 with (!s2 [← N]). eapply subst_gen. apply H1. constructor. trivial. intuition. trivial.
destruct H12. destruct H12; subst. left; simpl; split; trivial. right. change !a with (!a [ length l + 0 ← N']). rewrite <- Tels_subst.
apply typ_peq_trans with (B [ ← N']).  apply typ_peq_intro with s2. change !s2 with (!s2 [←N]). eapply subst_gen. apply red_refl_lt in H1; apply H1.
constructor. trivial. eapply peq_subst. apply H12. apply red_refl_rt in H3; apply H3. 
destruct H14. destruct H14; subst. right. simpl. intuition.  right. change !b with (!b [ length l + 0 ← N']). rewrite <- Tels_subst.
apply typ_peq_trans with (B [ ← N']).  apply typ_peq_trans with (B [ ← N]). intuition. apply typ_peq_intro with s2.
change !s2 with (!s2 [←N]). eapply subst_gen. apply red_refl_lt in H1; apply H1. constructor. trivial. eapply peq_subst.
apply H14. apply red_refl_rt in H3; apply H3.
change !a with (!a [length l  ← N']). change (Π (K [(length l) ← N']), L [(S (length l)) ← N']) with ((Π (K),L)[length l  ← N']). 
eapply subst_gen. apply H15. apply toto. apply red_refl_rt in H3;  trivial.
change !b with (!b [length l  ← N']). change (Π (K [(length l) ← N']), L [(S (length l)) ← N']) with ((Π (K),L)[length l  ← N']). 
eapply subst_gen. apply H17. apply toto. apply red_refl_rt in H3;  trivial.
(**)
destruct (IHtyp1 P B0 H1 H2). destruct H3 as ( k &  l & a & b &h ); decompose [and] h; clear h. left. exists k; exists l; exists a; exists b; repeat split.
apply reds_typ_pcompat with A. trivial. eauto. trivial. destruct H4. destruct H4 ; subst. left;split; trivial. apply pgen_sort in H0; intuition.
right. eauto. destruct H6. destruct H6; subst. left ; intuition. right. eauto. trivial. trivial.

destruct H3 as (K & L & l & a & b & h). decompose [and] h; clear h. right . exists K; exists L; exists l; exists a; exists b; repeat split.
apply reds_typ_pcompat with A. trivial. eauto. trivial. destruct H4. destruct H4; subst.  left; split; trivial. apply pgen_sort in H0; intuition.
right; eauto. destruct H6. destruct H6; subst. left; intuition. right; eauto. trivial. trivial.
(**)
destruct (IHtyp1 P B0 H1 H2). destruct H3 as ( k &  l & a & b &h ); decompose [and] h; clear h. left. exists k; exists l; exists a; exists b; repeat split.
apply reds_typ_pcompat with B. trivial. eauto. trivial. destruct H4. destruct H4 ; subst. right; eauto. right; eauto.
destruct H6. destruct H6; subst. left ; intuition. right. eauto. trivial. trivial.

destruct H3 as (K & L & l & a & b & h). decompose [and] h; clear h. right . exists K; exists L; exists l; exists a; exists b; repeat split.
apply reds_typ_pcompat with B. trivial. eauto. trivial. destruct H4. destruct H4; subst. right; eauto. right; eauto.
 destruct H6. destruct H6; subst. left; intuition. right; eauto. trivial. trivial.
Qed.

Hint Constructors Tv Ts.


Lemma Tx_ok : (forall M, Ts M \/ Tv M) /\ (forall M, Ts M -> Tv M -> False).
split. induction M; intuition.
induction M; intros. inversion H. inversion H0.
inversion H; subst; clear H. inversion H0; subst; clear H0. intuition.
inversion H0.
inversion H; subst; clear H. inversion H0; subst; clear H0. intuition.
Qed.



Lemma ErasedTermConfluence : forall M N Γ M' A N' B, strip M = strip N ->  Γ ⊢ M ▹ M' : A -> Γ ⊢ N ▹ N' : B -> 
  exists P,  Γ ⊢ M ▹▹ P : A /\ Γ ⊢ N ▹▹ P : B.
induction M; intros.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply red_refl_lt in H1. apply red_refl_lt in H0. exists #v0; intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply red_refl_lt in H1. apply red_refl_lt in H0. exists !s0; intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
rename M1 into P. rename M3 into Q. rename M2 into D.
rename N1 into P'. rename N3 into Q'. rename N2 into D'.
apply pgen_app in H0. destruct H0 as (C & C1 & D1 & Q1 & s1 & t1  & u1 & h). decompose [and] h ; clear h.
apply pgen_app in H1. destruct H1 as (C' & C'1 & D'1 & Q'1 & s2 & t2  & u2 & h). decompose [and] h ; clear h.
assert (exists PP, Γ ⊢ P ▹ PP : Π(C),D). destruct H8. destruct H8 as (P'' & ? & ?). exists P''; trivial.
destruct H8 as (K & K' & -> & ? & ?). exists (La C1 K'). econstructor. apply H. trivial. apply H0. trivial.
assert (exists PP', Γ ⊢ P' ▹ PP' : Π(C'),D'). destruct H13. destruct H13 as (P'' & ? & ?). exists P''; trivial.
destruct H13 as (K & K' & -> & ? & ?). exists (La C'1 K'). econstructor. apply H1. trivial. apply  H7. trivial.
destruct H12 as (PP & ?). destruct H14 as (PP' & ?). clear H8 H13.
destruct (IHM3 Q' Γ Q1 C Q'1 C'  H2 H5 H10) as (RQ & ? & ? ).
destruct (IHM1 P' Γ PP (Pi C D) PP' (Pi C' D') H3 H12 H14) as (RP & ? & ? ).
destruct Tx_ok. destruct (H17 RP). clear H17 H18. 
(* Ts *) 
destruct (typ_reds_to_red Γ P RP (Pi C D) H15) as ( _ & ?). destruct (typ_reds_to_red Γ P' RP (Pi C' D') H16) as ( _ & ?).
destruct (Ts_Shape Γ RP RP (Pi C D) H17 RP (Pi C' D') H18 H19). 
(* sort / sort *)
destruct H20 as (z & l & a & b & h). decompose [and] h; clear h. destruct H21. destruct H21; discriminate. destruct H23. destruct H23; discriminate.
destruct l. simpl in *. apply eq_typ_to_ut in H21; simpl in H21. apply ut_red.Betac_not_Pi_sort in H21; elim H21.
simpl in *. apply PiInj in H21 as (? & ?). apply PiInj in H23 as ( ?& ?). assert ( Γ ⊢ C ≡' C'). eauto.
exists ((Tels' l !z) [ ← RQ]); split. destruct (typ_reds_to_red Γ RP (λ [t], Tels' l !z) (Pi C D) H20) as  ( _ & ?).
apply pgen_la in H29 as (t' & Tl' & E & E' & u & v & w &  h). decompose [and] h; clear h. apply PiInj in H35 as (?& ?). apply red_refl_lt in H30.
apply reds_typ_pcompat with (D [ ← Q]); trivial. eapply typ_reds_trans. eapply reds_App.
apply H15. constructor;  apply red_refl_lt in H5; apply H5. constructor. apply red_refl_lt in H0; apply H0. eapply typ_reds_trans.
eapply reds_App. apply H20. constructor. apply red_refl_lt in H5; apply H5. constructor. apply red_refl_lt in H0;  apply H0.
eapply typ_reds_trans. constructor. destruct (sf u) with (t := t1) as ( W & ?). exists v; exists w; trivial.
eapply typ_beta. apply H36. apply H31. eapply conv_in_env. apply H0. eauto. apply typ_pcompat with E. apply H30.
trivial. apply typ_pcompat with C. apply red_refl_lt in H5; apply H5. intuition. eapply reds_subst_gen.
apply reds_typ_pcompat with E. constructor;  apply H30. trivial.  apply reds_typ_pcompat with C; intuition.

destruct (typ_reds_to_red Γ RP (λ [t], Tels' l !z) (Pi C' D') H22) as  ( _ & ?).
apply pgen_la in H29 as (t' & Tl' & E & E' & u & v & w &  h). decompose [and] h; clear h. apply PiInj in H35 as (?& ?).
apply reds_typ_pcompat with (D' [ ← Q']); trivial. eapply typ_reds_trans. eapply reds_App.
apply H16. constructor;  apply red_refl_lt in H10; apply H10. constructor. apply red_refl_lt in H7; apply H7. eapply typ_reds_trans.
eapply reds_App. apply H22. constructor. apply red_refl_lt in H10; apply H10. constructor. apply red_refl_lt in H7;  apply H7.
eapply typ_reds_trans. constructor. destruct (sf u) with (t := t2) as ( W & ?). exists v; exists w; trivial.
eapply typ_beta. apply H36. apply H31. eapply conv_in_env. apply H7. eauto. apply typ_pcompat with E. apply red_refl_lt in H30; apply H30.
trivial. apply typ_pcompat with C'. apply red_refl_lt in H10; apply H10. intuition. eapply reds_subst_gen.
apply reds_typ_pcompat with E. constructor; apply red_refl_lt in H30; apply H30. trivial.  apply reds_typ_pcompat with C'; intuition.


(* pi /  pi  *)
destruct H20 as (K & L & l & a & b &h). decompose [and] h; clear h. destruct H21. destruct H21; discriminate.
destruct H23. destruct H23; discriminate. destruct l; simpl in *. apply eq_typ_to_ut in H21; simpl in H21. apply ut_red.Betac_not_Pi_sort in H21; elim H21.
apply PiInj in H21 as (? & ?). apply PiInj in H23 as (? & ?). assert ( Γ ⊢ C ≡' C'). eauto.
exists ((Tels' l (Pi K L)) [ ← RQ]); split. destruct (typ_reds_to_red Γ RP (λ [t], Tels' l (Pi K L)) (Pi C D) H20) as  ( _ & ?).
apply pgen_la in H29 as (t' & Tl' & E & E' & u & v & w &  h). decompose [and] h; clear h. apply PiInj in H35 as (?& ?). apply red_refl_lt in H30.
apply reds_typ_pcompat with (D [ ← Q]); trivial. eapply typ_reds_trans. eapply reds_App.
apply H15. constructor. apply red_refl_lt in H5; apply H5. constructor. apply red_refl_lt in H0;  apply H0.  eapply typ_reds_trans.
eapply reds_App. apply H20. constructor. apply red_refl_lt in H5; apply H5. constructor. apply red_refl_lt in H0;  apply H0.
eapply typ_reds_trans. constructor. simpl. destruct (sf u) with (t := t1) as (W & ?). exists v; exists w; trivial. eapply typ_beta. apply H36. 
apply H31. eapply conv_in_env. apply H0. eauto. apply typ_pcompat with E. apply H30. trivial.
apply typ_pcompat with C. apply red_refl_lt in H5;  apply H5. trivial. eapply reds_subst_gen.
apply reds_typ_pcompat with E. constructor; apply H30. trivial. apply reds_typ_pcompat with C; intuition.

destruct (typ_reds_to_red Γ RP (λ [t], Tels' l (Pi K L)) (Pi C' D') H22) as  ( _ & ?).
apply pgen_la in H29 as (t' & Tl' & E & E' & u & v & w &  h). decompose [and] h; clear h. apply PiInj in H35 as (?& ?). apply red_refl_lt in H30.
apply reds_typ_pcompat with (D' [ ← Q']); trivial. eapply typ_reds_trans. eapply reds_App.
apply H16. constructor. apply red_refl_lt in H10; apply H10. constructor. apply red_refl_lt in H7;  apply H7.  eapply typ_reds_trans.
eapply reds_App. apply H22. constructor. apply red_refl_lt in H10; apply H10. constructor. apply red_refl_lt in H7;  apply H7.
eapply typ_reds_trans. constructor. simpl. destruct (sf u) with (t := t2) as (W & ?). exists v; exists w; trivial. eapply typ_beta. apply H36. 
apply H31. eapply conv_in_env. apply H7. eauto. apply typ_pcompat with E. apply H30. trivial.
apply typ_pcompat with C'. apply red_refl_lt in H10;  apply H10. trivial. eapply reds_subst_gen.
apply reds_typ_pcompat with E. constructor; apply H30. trivial. apply reds_typ_pcompat with C'; intuition.
(* TV *)
destruct (typ_reds_to_red Γ P RP (Pi C D) H15) as ( _ & ?).
destruct (typ_reds_to_red Γ P' RP (Pi C' D') H16) as ( _ & ?).
destruct (PiInj Γ C D C' D'). apply (ShapeOfType_Tv Γ RP RP (Pi C D) H20 RP (Pi C' D') H21). trivial.
apply Confluence in H23 as (Z & d1 & d2 & ? & ?).
exists (App RP Z RQ); split.
apply reds_typ_pcompat with (D [ ← Q]); trivial. eapply reds_App. apply  H15. trivial. apply H23.
apply reds_typ_pcompat with (D' [ ← Q']); trivial.  eapply reds_App. apply H16. trivial. eapply conv_in_env_reds. apply H24.
eauto.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply pgen_pi in H0. destruct H0 as (M1' & M2' & s1 & t1 & u1 & h). decompose [and] h; clear h.
apply pgen_pi in H1. destruct H1 as (N1' & N2' & s2 & t2 & u2 & h). decompose [and] h; clear h.
destruct (IHM1 N1 Γ M1' !s1 N1' !s2 H3 H4 H8) as (R1 &  ? & ?).
assert (Γ ⊢ M1 ≡' N1). apply typ_peq_trans with R1. apply reds_to_conv in H10; trivial. apply reds_to_conv in H12; intuition.
destruct (IHM2 N2 (M1::Γ) M2' !t1 N2' !t2 H2 H0 ) as (R2 & ? & ?).
eapply conv_in_env. apply H6. eauto. exists (Pi R1 R2); split.
destruct H7. subst.  eapply reds_Pi. apply H10. apply H14. trivial.
apply reds_typ_pcompat with !u1. eapply reds_Pi.  apply H10. apply H14. trivial. intuition.
destruct H11. subst.  eapply reds_Pi. apply H12. eapply conv_in_env_reds. apply H15. eauto. trivial.
apply reds_typ_pcompat with !u2. eapply reds_Pi. apply H12. eapply conv_in_env_reds. apply H15. eauto. trivial. intuition.
(**)
destruct N; simpl in H; try discriminate. injection H; intros; subst; clear H.
apply pgen_la in H0. destruct H0 as (M1' & M2' & D & D' & s1 & t1 & u1 & h). decompose [and] h; clear h.
apply pgen_la in H1. destruct H1 as (N1' & N2' & D2 & D2' & s2 & t2 & u2 & h). decompose [and] h; clear h.
destruct (IHM1 N1 Γ M1' !s1 N1' !s2 H3 H4 H9) as (R1 & ? & ? ).
assert (Γ ⊢ M1 ≡' N1). apply typ_peq_trans with R1. apply reds_to_conv in H12; trivial. apply reds_to_conv in H14; intuition.
destruct (IHM2 N2 (M1::Γ) M2' D N2' D2 H2) as (R2 & ? & ? ); trivial.
eapply conv_in_env. apply H7. eauto. exists (La R1 R2); split.
apply reds_typ_pcompat with (Π (M1), D); trivial. eapply reds_La.  apply H12. trivial. apply H5. apply H.
apply reds_typ_pcompat with (Π (N1), D2); trivial. eapply reds_La. apply H14. eapply conv_in_env_reds.  apply H17. eauto.
apply H10. apply H1.
Qed.

Lemma ErasedTypeConversion : forall A B Γ A' s B' t, strip A = strip B -> Γ ⊢ A ▹ A' : !s -> Γ ⊢ B ▹ B' : !t ->
  Γ ⊢ A ≡' B.
intros.
destruct (ErasedTermConfluence A B Γ A' !s B' !t H H0 H1) as ( P & ?&  ?).
apply typ_peq_trans with P. apply reds_to_conv in H2; trivial. apply reds_to_conv in H3; intuition.
Qed.

Lemma L43_ : forall Γ Γ', strip_env Γ = strip_env Γ' -> wf Γ -> wf Γ' -> env_conv Γ Γ'.
induction Γ; intros. destruct Γ'; simpl in H.
intuition. discriminate. destruct Γ'; simpl in *. discriminate.
injection H; intros; subst; clear H. eapply c_trans with (a::Γ').
apply env_conv_cons. inversion H0; subst; clear H0. econstructor. apply red_refl_lt in H4; apply H4.
inversion H1; inversion H0; subst; clear H0 H1. apply wf_from_typ in H4. apply wf_from_typ in H7. intuition.
apply env_conv_cons.  inversion H1; inversion H0; subst; clear H0 H1.
eapply ErasedTypeConversion. trivial. eapply conv_in_env. apply H7. apply IHΓ. trivial. apply wf_from_typ in H7; trivial.
apply wf_from_typ in H4; trivial. apply H4.  inversion H1; inversion H0; subst; clear H0 H1.
apply wf_from_typ in H4. apply wf_from_typ in H7. intuition.
Qed.


Lemma ErasedContextSwitch : forall Γ M N T, Γ ⊢ M ▹ N : T -> forall  Γ', wf Γ' -> strip_env  Γ = strip_env  Γ' -> Γ' ⊢ M ▹ N : T.
induction 1; intros.
apply conv_in_env with  Γ. intuition. apply L43_; trivial.
(**)
intuition.
(**)
apply typ_pi with s1 s2; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H3; trivial.
(**)
apply typ_la with B' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H4; trivial. eapply IHtyp3. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H4; trivial.
(**)
apply typ_app with A A' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial.
(**)
apply typ_beta with A' B' s1 s2 s3; intuition. eapply IHtyp2. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial. eapply IHtyp3. econstructor. eapply IHtyp1.
trivial. trivial. simpl; rewrite H5; trivial.
(**)
eauto.
(**)
eauto.
Qed.

Require Import red.

Lemma L33 : forall M N', ut_red.Beta (strip M) N' ->exists N, strip N = N' /\ Beta M N.
induction M; intros; simpl in *.
inversion H. inversion H.
inversion H; subst; clear H. destruct M1; simpl in *; try discriminate.
injection H1; intros; subst; clear H1.
exists ( M1_2 [ ← M3]); split. rewrite strip_subst. trivial. intuition.
destruct (IHM1 y H3) as (n & ? & ?). exists (App n M2 M3); split. simpl. subst. trivial.
intuition. destruct (IHM3 y H3) as (n & ? & ?). exists (App M1 M2 n); split. simpl. subst. trivial.
intuition. inversion H; subst; clear H. 
destruct (IHM2 y H3) as (n & ? & ?). exists (Pi M1 n); split. simpl. subst. trivial.
intuition. destruct (IHM1 B H3) as (n & ? & ?). exists (Pi n M2); split. simpl. subst. trivial.
intuition.  inversion H; subst; clear H. 
destruct (IHM2 y H3) as (n & ? & ?). exists (La M1 n); split. simpl. subst. trivial.
intuition. destruct (IHM1 B H3) as (n & ? & ?). exists (La n M2); split. simpl. subst. trivial.
intuition.
Qed.

Lemma L33' : forall M N', ut_red.Betas (strip M) N' ->exists N, strip N = N' /\ Betas M N.
intros. remember (strip M) as MM. revert M HeqMM. induction H; intros; subst.
exists M; intuition. apply L33 in H as (N & ? & ?).
exists N; intuition. destruct (IHBetas1 M ) as (N & ? & ?); trivial.
destruct (IHBetas2 N) as (NN & ?& ?). intuition.
exists NN; intuition. eauto.
Qed.

Lemma FromPTS_to_TPOSR : (forall Γ  M A , ut_typ.typ Γ M A -> exists Γ', exists M', exists A', strip_env Γ' = Γ /\ 
  strip M' = M /\ strip A' = A /\ Γ' ⊢ M' ▹ M' : A') /\
        (forall Γ , ut_typ.wf Γ -> exists Γ', strip_env Γ' = Γ /\ wf Γ').
apply ut_typ.typ_induc; intros.
destruct H as (Γ' & ? & ?). exists Γ'; exists !s; exists !t; intuition.
(**)
destruct H as (ΓΓ & ? & ?). assert (exists AA, AA ↓ v ⊂ ΓΓ /\ A = strip AA).
clear w H0. revert ΓΓ A v H i. induction Γ; intros. destruct i as ( a & ? &?).
inversion H1. destruct ΓΓ; simpl in H. discriminate. injection H; intros; subst; clear H.
destruct i as (a &? & ?). inversion H0; subst; clear H0. exists (lift_rec 1 0 t).
split. exists t. intuition. rewrite strip_lift; trivial. 
destruct (IHΓ ΓΓ (ut_term.lift_rec (S n) 0 a) n) as (B & ?& ?). trivial.
exists a; intuition. exists (lift_rec 1 0 B). split. destruct H as (b & ?& ?).
exists b. subst. rewrite lift_lift; intuition. rewrite strip_lift. rewrite <- H0.
rewrite ut_term.lift_lift. trivial.
destruct H1 as (B &? & ?). exists ΓΓ; exists #v; exists B; simpl; intuition.
(**)
destruct H as (Γa & A' & ? & ? & ? & ? & ?). destruct x; simpl in H2; try discriminate.
injection H2; intros; subst; clear H2.
destruct H0 as (Γb & B' & ? & ? & ? & ? & ?). destruct x; simpl in H1; try discriminate.
injection H1; intros; subst; clear H1.
exists Γa ; exists (Pi A' B'); exists !u; simpl; intuition. econstructor.
apply r. trivial. eapply ErasedContextSwitch. apply H2. econstructor. eapply H3. simpl; trivial.
(**)
destruct H as (Γa & Ma & ? & ? & ?& ? & ?). destruct x; simpl in H3; try discriminate.
injection H3; intros; subst; clear H3. destruct H0 as (Γb & Mb & ? & ? & ? & ? & ?).
destruct x; simpl in H2; try discriminate. injection H2; intros; subst; clear H2.
destruct H1 as (Γm & M' & B' & ? & ?& ? &?). destruct Γb; simpl in H. discriminate.
injection H; intros; subst; clear H. destruct Γm; simpl in H0. discriminate.
injection  H0; intros; subst; clear H0.
exists Γa; exists (La Ma M'); exists (Pi Ma Mb); simpl; intuition. econstructor.
apply r. trivial. eapply ErasedContextSwitch. apply H3. econstructor. apply H4. simpl. rewrite H6. rewrite H7. trivial.
destruct (typ_wf (t3 :: Γm)  M' M' B' H5). destruct H0; subst. simpl in H2; destruct Mb; try discriminate.
simpl in H2. injection H2; intros; subst; clear H2. eapply ErasedContextSwitch. apply H5.  econstructor. apply H4.
simpl. rewrite H1; rewrite H; trivial. destruct H0 as ( x & ?).
eapply ErasedContextSwitch. apply typ_pcompat with B'. apply H5. eapply ErasedTypeConversion. trivial. apply H0. 
eapply ErasedContextSwitch. apply H3. apply wf_from_typ in H0; trivial. simpl. rewrite H7; rewrite H1; rewrite H6; rewrite H; trivial.
econstructor. apply H4. simpl. rewrite H1; rewrite H; trivial.
(**)
destruct H as (Γm & Mm & Tm & ? & ? & ? &?). destruct Tm; simpl in *; try discriminate. 
injection H2; intros; subst; clear H2. destruct H0 as (Γn & Mn & Tn &? & ? & ?& ?).
exists Γm; exists (App Mm Tm2 Mn); exists (Tm2  [ ← Mn]); intuition.
subst. simpl. trivial. rewrite strip_subst. subst. trivial.
assert (exists u, Γm ⊢ Π (Tm1),Tm2 ▹ Π(Tm1),Tm2 : !u). apply typ_wf in H3.
destruct H3. destruct H3 ; discriminate. trivial. destruct H4 as (u& ?).
apply pgen_pi in H4 as (Tm1' & Tm2' & s1 & s2 & s3 & h); decompose [and] h; clear h.
injection H7; intros; subst; clear H7.
econstructor. apply H4. apply H6. trivial. trivial. apply typ_pcompat with Tn. eapply ErasedContextSwitch.
apply H2. apply wf_from_typ in H6; trivial. trivial. apply typ_wf in H2. destruct H2 as [ [ s ?] | [s ?] ].
subst. destruct Tm1'; simpl in H1; try discriminate. injection H1; intros; subst; clear H1.
econstructor. apply H6. eapply ErasedTypeConversion. trivial. eapply ErasedContextSwitch. apply H0. apply wf_from_typ in H6; trivial.
trivial. apply H6.
(**)
rename a into M.
destruct H as (Γ' & M' & A' & ? & ? & ? & ?). destruct H0 as (Γ2 & B' & Tb & ? & ?& ?& ?).
destruct Tb; simpl in H5; try discriminate. injection H5; intros; subst; clear H5.
destruct (typ_wf Γ' M' M' A' H3). destruct H as (a & ?). subst; simpl in b.
apply conv_to_sort in b.
apply L33' in b. destruct b as ( n & ? & ?). destruct n; simpl in H; try discriminate.
injection H; intros; subst; clear H.
exists Γ'; exists M' ; exists B'; intuition. apply typ_pcompat with !a.
trivial. apply typ_peq_sym. apply reds_to_conv with s.
apply SR_trans' with B'; trivial. eapply ErasedContextSwitch. apply H6. apply wf_from_typ in H3; trivial. trivial.
destruct H as (sA' & ?). apply Betac_confl in b as (C & ?& ?).
apply L33' in H1 as (C0 & ? & ?). apply L33' in H2 as (C1 & ? & ?).
exists Γ'; exists M'; exists B'; intuition. eapply typ_pcompat with A'.
trivial. assert (Γ' ⊢ A' ▹▹ C0 : !sA').   apply SR_trans' with A'. trivial. trivial.
assert (Γ' ⊢ B' ▹▹ C1 : !s).   apply SR_trans' with B'. trivial. eapply ErasedContextSwitch.
apply H6. apply wf_from_typ in H3; trivial. trivial. apply typ_peq_trans with C0.
apply reds_to_conv with sA'; trivial.  apply typ_peq_trans with C1.
eapply ErasedTypeConversion. rewrite H1. rewrite H2. trivial. apply typ_reds_to_red in H7 as (_ & ?).
apply H7. apply typ_reds_to_red in H8 as (_ & ?). apply H8.  apply typ_peq_sym.
apply reds_to_conv with s; trivial.
(** wf **)
exists nil; simpl; intuition.
(**)
destruct H as (Γ' & M' & A' & ? & ? & ? & ?).
destruct A'; simpl in H1; try discriminate. injection H1; intros; subst; clear H1.
exists (M'::Γ'); simpl; intuition. econstructor. apply H2.
Qed.



